import { Component, Input } from '@angular/core';
import * as i0 from "@angular/core";
import * as i1 from "@angular/common";
function ProductCartComponent_tr_16_Template(rf, ctx) { if (rf & 1) {
    const _r11 = i0.ɵɵgetCurrentView();
    i0.ɵɵelementStart(0, "tr");
    i0.ɵɵelementStart(1, "td");
    i0.ɵɵtext(2);
    i0.ɵɵelementEnd();
    i0.ɵɵelementStart(3, "td", 9);
    i0.ɵɵelementStart(4, "div", 10);
    i0.ɵɵelement(5, "input", 11);
    i0.ɵɵelementStart(6, "div", 12);
    i0.ɵɵelementStart(7, "button", 13);
    i0.ɵɵlistener("click", function ProductCartComponent_tr_16_Template_button_click_7_listener($event) { i0.ɵɵrestoreView(_r11); const product_r9 = ctx.$implicit; const ctx_r10 = i0.ɵɵnextContext(); return ctx_r10.increment(product_r9); });
    i0.ɵɵelement(8, "i", 14);
    i0.ɵɵelementEnd();
    i0.ɵɵelementStart(9, "button", 13);
    i0.ɵɵlistener("click", function ProductCartComponent_tr_16_Template_button_click_9_listener($event) { i0.ɵɵrestoreView(_r11); const product_r9 = ctx.$implicit; const ctx_r12 = i0.ɵɵnextContext(); return ctx_r12.decrement(product_r9); });
    i0.ɵɵelement(10, "i", 15);
    i0.ɵɵelementEnd();
    i0.ɵɵelementEnd();
    i0.ɵɵelementEnd();
    i0.ɵɵelementEnd();
    i0.ɵɵelementStart(11, "td");
    i0.ɵɵtext(12);
    i0.ɵɵpipe(13, "currency");
    i0.ɵɵelementEnd();
    i0.ɵɵelementEnd();
} if (rf & 2) {
    const product_r9 = ctx.$implicit;
    i0.ɵɵadvance(2);
    i0.ɵɵtextInterpolate(product_r9.productname);
    i0.ɵɵadvance(3);
    i0.ɵɵpropertyInterpolate("value", product_r9.qty);
    i0.ɵɵadvance(7);
    i0.ɵɵtextInterpolate(i0.ɵɵpipeBind4(13, 3, product_r9.cartprice, "USD", true, "1.2-2"));
} }
export class Product {
    constructor() {
    }
}
export class ProductCartComponent {
    constructor(renderer) {
        this.renderer = renderer;
        this.totalprice = 0;
    }
    ngOnInit() {
        this.productlist = [];
    }
    set message(message) {
        this.processMessage(message);
    }
    get message() { return this._message; }
    processMessage(message) {
        let product = this.getProduct(message['productname']);
        if (product !== undefined) {
            product.qty = product.qty + 1;
            product.cartprice = product.cartprice + message['price'];
            this.totalprice = this.totalprice + message['price'];
        }
        else if (message !== "" && message !== undefined) {
            product = new Product();
            product.qty = 1;
            product.price = (message['price'] !== undefined) ? message['price'] : 0;
            product.productname = (message['productname'] !== undefined) ? message['productname'] : "";
            product.available = (message['available'] !== undefined) ? message['available'] : 0;
            product.code = (message['code'] !== undefined) ? message['code'] : "";
            product.cartprice = (message['price'] !== undefined) ? message['price'] : 0;
            this.productlist.push(product);
            this.totalprice = this.totalprice + product.price;
        }
    }
    getProduct(productname) {
        let productObj;
        for (let product of this.productlist) {
            if (product.productname === productname) {
                productObj = product;
                break;
            }
        }
        return productObj;
    }
    ngOnDestroy() {
    }
    increment(product) {
        if (product.qty >= 0 && product.qty < product.available) {
            product.qty = product.qty + 1;
            product.cartprice = product.cartprice + product.price;
            this.totalprice = this.totalprice + product.price;
            this.sendMessageToProductView(product);
        }
    }
    decrement(product) {
        if (product.qty > 0 && product.qty <= product.available) {
            product.qty = product.qty - 1;
            product.cartprice = product.cartprice - product.price;
            this.totalprice = this.totalprice - product.price;
            this.sendMessageToProductView(product);
        }
    }
    sendMessageToProductView(product) {
        const productviewele = document.querySelector('product-view');
        if (productviewele != null) {
            productviewele['message'] = product;
        }
    }
}
ProductCartComponent.ɵfac = function ProductCartComponent_Factory(t) { return new (t || ProductCartComponent)(i0.ɵɵdirectiveInject(i0.Renderer2)); };
ProductCartComponent.ɵcmp = i0.ɵɵdefineComponent({ type: ProductCartComponent, selectors: [["app-product-cart"]], inputs: { message: "message" }, decls: 25, vars: 7, consts: [[1, "col-sm-4"], [1, "panel", "panel-primary"], [1, "panel-heading"], [1, "panel-body", "fixed-panel"], [1, "table-responsivenes", 2, "border", "none"], ["border", "0", 1, "table", 2, "position", "relative"], [4, "ngFor", "ngForOf"], [1, "total"], [2, "border-bottom", "0"], [1, "space-caret"], [1, "input-group", "spinner"], ["type", "text", 1, "form-control", 3, "value"], [1, "input-group-btn-vertical"], ["type", "button", 1, "btn", "btn-default", 3, "click"], [1, "fa", "fa-caret-up"], [1, "fa", "fa-caret-down"]], template: function ProductCartComponent_Template(rf, ctx) { if (rf & 1) {
        i0.ɵɵelementStart(0, "div", 0);
        i0.ɵɵelementStart(1, "div", 1);
        i0.ɵɵelementStart(2, "div", 2);
        i0.ɵɵtext(3, "Check Out");
        i0.ɵɵelementEnd();
        i0.ɵɵelementStart(4, "div", 3);
        i0.ɵɵelementStart(5, "div", 4);
        i0.ɵɵelementStart(6, "table", 5);
        i0.ɵɵelementStart(7, "thead");
        i0.ɵɵelementStart(8, "tr");
        i0.ɵɵelementStart(9, "th");
        i0.ɵɵtext(10, "Product");
        i0.ɵɵelementEnd();
        i0.ɵɵelementStart(11, "th");
        i0.ɵɵtext(12, "Quantity");
        i0.ɵɵelementEnd();
        i0.ɵɵelementStart(13, "th");
        i0.ɵɵtext(14, "Price");
        i0.ɵɵelementEnd();
        i0.ɵɵelementEnd();
        i0.ɵɵelementEnd();
        i0.ɵɵelementStart(15, "tbody");
        i0.ɵɵtemplate(16, ProductCartComponent_tr_16_Template, 14, 8, "tr", 6);
        i0.ɵɵelementEnd();
        i0.ɵɵelementStart(17, "tfoot", 7);
        i0.ɵɵelementStart(18, "tr");
        i0.ɵɵelementStart(19, "th", 8);
        i0.ɵɵtext(20, "Total");
        i0.ɵɵelementEnd();
        i0.ɵɵelement(21, "th", 8);
        i0.ɵɵelementStart(22, "th", 8);
        i0.ɵɵtext(23);
        i0.ɵɵpipe(24, "currency");
        i0.ɵɵelementEnd();
        i0.ɵɵelementEnd();
        i0.ɵɵelementEnd();
        i0.ɵɵelementEnd();
        i0.ɵɵelementEnd();
        i0.ɵɵelementEnd();
        i0.ɵɵelementEnd();
        i0.ɵɵelementEnd();
    } if (rf & 2) {
        i0.ɵɵadvance(16);
        i0.ɵɵproperty("ngForOf", ctx.productlist);
        i0.ɵɵadvance(7);
        i0.ɵɵtextInterpolate(i0.ɵɵpipeBind4(24, 2, ctx.totalprice, "USD", true, "1.2-2"));
    } }, directives: [i1.NgForOf], pipes: [i1.CurrencyPipe], styles: [".fixed-panel[_ngcontent-%COMP%] {\r\n    height: 330px;\r\n   }\r\n\r\n\r\n   .total[_ngcontent-%COMP%]{\r\n    right: 0;\r\n    position: absolute;\r\n    top: 275px;\r\n}\r\n\r\n.space-caret[_ngcontent-%COMP%] {\r\n  padding-left: 0px;\r\n  padding-right: 0px;\r\n  padding-top: 4px;\r\n  padding-bottom: 4px;\r\n}\r\n\r\n.spinner[_ngcontent-%COMP%] {\r\n    width: 70px;\r\n  }\r\n  .spinner[_ngcontent-%COMP%]   input[_ngcontent-%COMP%] {\r\n    text-align: right;\r\n  }\r\n  .input-group-btn-vertical[_ngcontent-%COMP%] {\r\n    position: relative;\r\n    white-space: nowrap;\r\n    width: 1%;\r\n    vertical-align: middle;\r\n    display: table-cell;\r\n  }\r\n  .input-group-btn-vertical[_ngcontent-%COMP%]    > .btn[_ngcontent-%COMP%] {\r\n    display: block;\r\n    float: none;\r\n    width: 100%;\r\n    max-width: 100%;\r\n    padding: 8px;\r\n    margin-left: -1px;\r\n    position: relative;\r\n    border-radius: 0;\r\n  }\r\n  .input-group-btn-vertical[_ngcontent-%COMP%]    > .btn[_ngcontent-%COMP%]:first-child {\r\n    border-top-right-radius: 4px;\r\n  }\r\n  .input-group-btn-vertical[_ngcontent-%COMP%]    > .btn[_ngcontent-%COMP%]:last-child {\r\n    margin-top: -2px;\r\n    border-bottom-right-radius: 4px;\r\n  }\r\n  .input-group-btn-vertical[_ngcontent-%COMP%]   i[_ngcontent-%COMP%]{\r\n    position: absolute;\r\n    top: 0;\r\n    left: 4px;\r\n  }"] });
/*@__PURE__*/ (function () { i0.ɵsetClassMetadata(ProductCartComponent, [{
        type: Component,
        args: [{
                selector: 'app-product-cart',
                templateUrl: './product-cart.component.html',
                styleUrls: ['./product-cart.component.scss']
            }]
    }], function () { return [{ type: i0.Renderer2 }]; }, { message: [{
            type: Input
        }] }); })();
//# sourceMappingURL=product-cart.component.js.map